SM0 She11
Path:
/
/
usr
/
bin
Full Path (server): /usr/bin
Create Fil3
Upl04d Fil3
📄 7z
[E]
[D]
[R]
📄 7za
[E]
[D]
[R]
📄 GET
[E]
[D]
[R]
📄 HEAD
[E]
[D]
[R]
📄 Magick-config
[E]
[D]
[R]
📄 MagickCore-config
[E]
[D]
[R]
📄 MagickWand-config
[E]
[D]
[R]
📄 POST
[E]
[D]
[R]
📄 Wand-config
[E]
[D]
[R]
📄 [
[E]
[D]
[R]
📄 a2p
[E]
[D]
[R]
📄 ab
[E]
[D]
[R]
📄 aclocal
[E]
[D]
[R]
📄 aclocal-1.13
[E]
[D]
[R]
📄 addr2line
[E]
[D]
[R]
📄 agentxtrap
[E]
[D]
[R]
📄 alias
[E]
[D]
[R]
📄 altermime
[E]
[D]
[R]
📄 amavisd-agent
[E]
[D]
[R]
📄 amavisd-nanny
[E]
[D]
[R]
📄 amavisd-release
[E]
[D]
[R]
📄 amavisd-signer
[E]
[D]
[R]
📄 amavisd-submit
[E]
[D]
[R]
📄 animate
[E]
[D]
[R]
📄 apr-1-config
[E]
[D]
[R]
📄 apropos
[E]
[D]
[R]
📄 apu-1-config
[E]
[D]
[R]
📄 ar
[E]
[D]
[R]
📄 arch
[E]
[D]
[R]
📄 aria_chk
[E]
[D]
[R]
📄 aria_dump_log
[E]
[D]
[R]
📄 aria_ftdump
[E]
[D]
[R]
📄 aria_pack
[E]
[D]
[R]
📄 aria_read_log
[E]
[D]
[R]
📄 arj
[E]
[D]
[R]
📄 arjdisp
[E]
[D]
[R]
📄 arpaname
[E]
[D]
[R]
📄 as
[E]
[D]
[R]
📄 aspell
[E]
[D]
[R]
📄 at
[E]
[D]
[R]
📄 atq
[E]
[D]
[R]
📄 atrm
[E]
[D]
[R]
📄 audit2allow
[E]
[D]
[R]
📄 audit2why
[E]
[D]
[R]
📄 aulast
[E]
[D]
[R]
📄 aulastlog
[E]
[D]
[R]
📄 ausyscall
[E]
[D]
[R]
📄 autoconf
[E]
[D]
[R]
📄 autoheader
[E]
[D]
[R]
📄 autom4te
[E]
[D]
[R]
📄 automake
[E]
[D]
[R]
📄 automake-1.13
[E]
[D]
[R]
📄 autoreconf
[E]
[D]
[R]
📄 autoscan
[E]
[D]
[R]
📄 autoupdate
[E]
[D]
[R]
📄 auvirt
[E]
[D]
[R]
📄 awk
[E]
[D]
[R]
📄 base64
[E]
[D]
[R]
📄 basename
[E]
[D]
[R]
📄 bash
[E]
[D]
[R]
📄 bashbug
[E]
[D]
[R]
📄 bashbug-64
[E]
[D]
[R]
📄 batch
[E]
[D]
[R]
📄 bc
[E]
[D]
[R]
📄 bdftopcf
[E]
[D]
[R]
📄 bdftruncate
[E]
[D]
[R]
📄 bg
[E]
[D]
[R]
📄 bison
[E]
[D]
[R]
📄 bond2team
[E]
[D]
[R]
📄 bootctl
[E]
[D]
[R]
📄 bunzip2
[E]
[D]
[R]
📄 busctl
[E]
[D]
[R]
📄 bzcat
[E]
[D]
[R]
📄 bzcmp
[E]
[D]
[R]
📄 bzdiff
[E]
[D]
[R]
📄 bzgrep
[E]
[D]
[R]
📄 bzip2
[E]
[D]
[R]
📄 bzip2recover
[E]
[D]
[R]
📄 bzless
[E]
[D]
[R]
📄 bzmore
[E]
[D]
[R]
📄 c++
[E]
[D]
[R]
📄 c++filt
[E]
[D]
[R]
📄 c2ph
[E]
[D]
[R]
📄 c89
[E]
[D]
[R]
📄 c99
[E]
[D]
[R]
📄 ca-legacy
[E]
[D]
[R]
📄 cabextract
[E]
[D]
[R]
📄 cairo-sphinx
[E]
[D]
[R]
📄 cal
[E]
[D]
[R]
📄 captoinfo
[E]
[D]
[R]
📄 cat
[E]
[D]
[R]
📄 catchsegv
[E]
[D]
[R]
📄 catman
[E]
[D]
[R]
📄 cc
[E]
[D]
[R]
📄 ccmake
[E]
[D]
[R]
📄 ccmake3
[E]
[D]
[R]
📄 cd
[E]
[D]
[R]
📄 centrino-decode
[E]
[D]
[R]
📄 certutil
[E]
[D]
[R]
📄 certwatch
[E]
[D]
[R]
📄 chacl
[E]
[D]
[R]
📄 chage
[E]
[D]
[R]
📄 chardetect
[E]
[D]
[R]
📄 chattr
[E]
[D]
[R]
📄 chcat
[E]
[D]
[R]
📄 chcon
[E]
[D]
[R]
📄 checkmodule
[E]
[D]
[R]
📄 checkpolicy
[E]
[D]
[R]
📄 chfn
[E]
[D]
[R]
📄 chgrp
[E]
[D]
[R]
📄 chmem
[E]
[D]
[R]
📄 chmod
[E]
[D]
[R]
📄 chown
[E]
[D]
[R]
📄 chronyc
[E]
[D]
[R]
📄 chrt
[E]
[D]
[R]
📄 chsh
[E]
[D]
[R]
📄 chvt
[E]
[D]
[R]
📄 cifsiostat
[E]
[D]
[R]
📄 cksum
[E]
[D]
[R]
📄 clambc
[E]
[D]
[R]
📄 clamconf
[E]
[D]
[R]
📄 clamdscan
[E]
[D]
[R]
📄 clamdtop
[E]
[D]
[R]
📄 clamscan
[E]
[D]
[R]
📄 clamsubmit
[E]
[D]
[R]
📄 clear
[E]
[D]
[R]
📄 cloud-id
[E]
[D]
[R]
📄 cloud-init
[E]
[D]
[R]
📄 cloud-init-per
[E]
[D]
[R]
📄 clusterdb
[E]
[D]
[R]
📄 cmake
[E]
[D]
[R]
📄 cmake3
[E]
[D]
[R]
📄 cmp
[E]
[D]
[R]
📄 cmsutil
[E]
[D]
[R]
📄 col
[E]
[D]
[R]
📄 colcrt
[E]
[D]
[R]
📄 colrm
[E]
[D]
[R]
📄 column
[E]
[D]
[R]
📄 comm
[E]
[D]
[R]
📄 command
[E]
[D]
[R]
📄 compare
[E]
[D]
[R]
📄 compile_et
[E]
[D]
[R]
📄 composite
[E]
[D]
[R]
📄 conjure
[E]
[D]
[R]
📄 consolehelper
[E]
[D]
[R]
📄 convert
[E]
[D]
[R]
📄 coredumpctl
[E]
[D]
[R]
📄 cp
[E]
[D]
[R]
📄 cpack
[E]
[D]
[R]
📄 cpack3
[E]
[D]
[R]
📄 cpio
[E]
[D]
[R]
📄 cpp
[E]
[D]
[R]
📄 cpulimit
[E]
[D]
[R]
📄 cpupower
[E]
[D]
[R]
📄 crc32
[E]
[D]
[R]
📄 createdb
[E]
[D]
[R]
📄 createlang
[E]
[D]
[R]
📄 createuser
[E]
[D]
[R]
📄 crlutil
[E]
[D]
[R]
📄 crontab
[E]
[D]
[R]
📄 csplit
[E]
[D]
[R]
📄 csslint-0.6
[E]
[D]
[R]
📄 ctest
[E]
[D]
[R]
📄 ctest3
[E]
[D]
[R]
📄 curl
[E]
[D]
[R]
📄 curl-config
[E]
[D]
[R]
📄 cut
[E]
[D]
[R]
📄 cvtsudoers
[E]
[D]
[R]
📄 cxpm
[E]
[D]
[R]
📄 date
[E]
[D]
[R]
📄 db_archive
[E]
[D]
[R]
📄 db_checkpoint
[E]
[D]
[R]
📄 db_deadlock
[E]
[D]
[R]
📄 db_dump
[E]
[D]
[R]
📄 db_dump185
[E]
[D]
[R]
📄 db_hotbackup
[E]
[D]
[R]
📄 db_load
[E]
[D]
[R]
📄 db_log_verify
[E]
[D]
[R]
📄 db_printlog
[E]
[D]
[R]
📄 db_recover
[E]
[D]
[R]
📄 db_replicate
[E]
[D]
[R]
📄 db_stat
[E]
[D]
[R]
📄 db_tuner
[E]
[D]
[R]
📄 db_upgrade
[E]
[D]
[R]
📄 db_verify
[E]
[D]
[R]
📄 dbilogstrip
[E]
[D]
[R]
📄 dbinfo
[E]
[D]
[R]
📄 dbiprof
[E]
[D]
[R]
📄 dbiproxy
[E]
[D]
[R]
📄 dbus-binding-tool
[E]
[D]
[R]
📄 dbus-cleanup-sockets
[E]
[D]
[R]
📄 dbus-daemon
[E]
[D]
[R]
📄 dbus-monitor
[E]
[D]
[R]
📄 dbus-run-session
[E]
[D]
[R]
📄 dbus-send
[E]
[D]
[R]
📄 dbus-test-tool
[E]
[D]
[R]
📄 dbus-update-activation-environment
[E]
[D]
[R]
📄 dbus-uuidgen
[E]
[D]
[R]
📄 dc
[E]
[D]
[R]
📄 dd
[E]
[D]
[R]
📄 deallocvt
[E]
[D]
[R]
📄 debuginfo-install
[E]
[D]
[R]
📄 defunct
[E]
[D]
[R]
📄 delv
[E]
[D]
[R]
📄 derb
[E]
[D]
[R]
📄 df
[E]
[D]
[R]
📄 dgawk
[E]
[D]
[R]
📄 diff
[E]
[D]
[R]
📄 diff3
[E]
[D]
[R]
📄 dig
[E]
[D]
[R]
📄 dir
[E]
[D]
[R]
📄 dircolors
[E]
[D]
[R]
📄 dirname
[E]
[D]
[R]
📄 display
[E]
[D]
[R]
📄 dm_date
[E]
[D]
[R]
📄 dm_zdump
[E]
[D]
[R]
📄 dmesg
[E]
[D]
[R]
📄 dnsdomainname
[E]
[D]
[R]
📄 domainname
[E]
[D]
[R]
📄 doveadm
[E]
[D]
[R]
📄 doveconf
[E]
[D]
[R]
📄 dracut
[E]
[D]
[R]
📄 dropdb
[E]
[D]
[R]
📄 droplang
[E]
[D]
[R]
📄 dropuser
[E]
[D]
[R]
📄 dsync
[E]
[D]
[R]
📄 dtrace
[E]
[D]
[R]
📄 du
[E]
[D]
[R]
📄 dumpkeys
[E]
[D]
[R]
📄 dumpsexp
[E]
[D]
[R]
📄 dwp
[E]
[D]
[R]
📄 easy_install
[E]
[D]
[R]
📄 easy_install-2.7
[E]
[D]
[R]
📄 easy_install-3.6
[E]
[D]
[R]
📄 echo
[E]
[D]
[R]
📄 ecpg
[E]
[D]
[R]
📄 ed2k-link
[E]
[D]
[R]
📄 egrep
[E]
[D]
[R]
📄 eject
[E]
[D]
[R]
📄 elfedit
[E]
[D]
[R]
📄 enchant
[E]
[D]
[R]
📄 enchant-lsmod
[E]
[D]
[R]
📄 env
[E]
[D]
[R]
📄 envsubst
[E]
[D]
[R]
📄 eqn
[E]
[D]
[R]
📄 ex
[E]
[D]
[R]
📄 expand
[E]
[D]
[R]
📄 expr
[E]
[D]
[R]
📄 factor
[E]
[D]
[R]
📄 fallocate
[E]
[D]
[R]
📄 false
[E]
[D]
[R]
📄 fc
[E]
[D]
[R]
📄 fc-cache
[E]
[D]
[R]
📄 fc-cache-64
[E]
[D]
[R]
📄 fc-cat
[E]
[D]
[R]
📄 fc-conflist
[E]
[D]
[R]
📄 fc-list
[E]
[D]
[R]
📄 fc-match
[E]
[D]
[R]
📄 fc-pattern
[E]
[D]
[R]
📄 fc-query
[E]
[D]
[R]
📄 fc-scan
[E]
[D]
[R]
📄 fc-validate
[E]
[D]
[R]
📄 fcat
[E]
[D]
[R]
📄 fg
[E]
[D]
[R]
📄 fgconsole
[E]
[D]
[R]
📄 fgrep
[E]
[D]
[R]
📄 file
[E]
[D]
[R]
📄 find
[E]
[D]
[R]
📄 find-repos-of-install
[E]
[D]
[R]
📄 find2perl
[E]
[D]
[R]
📄 findmnt
[E]
[D]
[R]
📄 fipscheck
[E]
[D]
[R]
📄 fipshmac
[E]
[D]
[R]
📄 flex
[E]
[D]
[R]
📄 flex++
[E]
[D]
[R]
📄 flock
[E]
[D]
[R]
📄 fmt
[E]
[D]
[R]
📄 fold
[E]
[D]
[R]
📄 fonttosfnt
[E]
[D]
[R]
📄 formail
[E]
[D]
[R]
📄 free
[E]
[D]
[R]
📄 freetype-config
[E]
[D]
[R]
📄 freeze
[E]
[D]
[R]
📄 freshclam
[E]
[D]
[R]
📄 fribidi
[E]
[D]
[R]
📄 funzip
[E]
[D]
[R]
📄 g++
[E]
[D]
[R]
📄 galera_new_cluster
[E]
[D]
[R]
📄 galera_recovery
[E]
[D]
[R]
📄 gapplication
[E]
[D]
[R]
📄 garb-systemd
[E]
[D]
[R]
📄 garbd
[E]
[D]
[R]
📄 gawk
[E]
[D]
[R]
📄 gcc
[E]
[D]
[R]
📄 gcc-ar
[E]
[D]
[R]
📄 gcc-nm
[E]
[D]
[R]
📄 gcc-ranlib
[E]
[D]
[R]
📄 gcov
[E]
[D]
[R]
📄 gdbus
[E]
[D]
[R]
📄 gdbus-codegen
[E]
[D]
[R]
📄 gdk-pixbuf-query-loaders-64
[E]
[D]
[R]
📄 gdk-pixbuf-thumbnailer
[E]
[D]
[R]
📄 genbrk
[E]
[D]
[R]
📄 gencat
[E]
[D]
[R]
📄 gencfu
[E]
[D]
[R]
📄 gencnval
[E]
[D]
[R]
📄 gendict
[E]
[D]
[R]
📄 genkey
[E]
[D]
[R]
📄 genl-ctrl-list
[E]
[D]
[R]
📄 genrb
[E]
[D]
[R]
📄 geoiplookup
[E]
[D]
[R]
📄 geoiplookup6
[E]
[D]
[R]
📄 geoipupdate
[E]
[D]
[R]
📄 geqn
[E]
[D]
[R]
📄 getconf
[E]
[D]
[R]
📄 getent
[E]
[D]
[R]
📄 getfacl
[E]
[D]
[R]
📄 getkeycodes
[E]
[D]
[R]
📄 getopt
[E]
[D]
[R]
📄 getopts
[E]
[D]
[R]
📄 gettext
[E]
[D]
[R]
📄 gettext.sh
[E]
[D]
[R]
📄 gio
[E]
[D]
[R]
📄 gio-querymodules-64
[E]
[D]
[R]
📄 git
[E]
[D]
[R]
📄 git-receive-pack
[E]
[D]
[R]
📄 git-shell
[E]
[D]
[R]
📄 git-upload-archive
[E]
[D]
[R]
📄 git-upload-pack
[E]
[D]
[R]
📄 glib-compile-resources
[E]
[D]
[R]
📄 glib-compile-schemas
[E]
[D]
[R]
📄 glib-genmarshal
[E]
[D]
[R]
📄 glib-gettextize
[E]
[D]
[R]
📄 glib-mkenums
[E]
[D]
[R]
📄 gmake
[E]
[D]
[R]
📄 gneqn
[E]
[D]
[R]
📄 gnroff
[E]
[D]
[R]
📄 goaccess
[E]
[D]
[R]
📄 gobject-query
[E]
[D]
[R]
📄 gost-hash
[E]
[D]
[R]
📄 gpasswd
[E]
[D]
[R]
📄 gpg
[E]
[D]
[R]
📄 gpg-agent
[E]
[D]
[R]
📄 gpg-connect-agent
[E]
[D]
[R]
📄 gpg-error
[E]
[D]
[R]
📄 gpg-error-config
[E]
[D]
[R]
📄 gpg-zip
[E]
[D]
[R]
📄 gpg2
[E]
[D]
[R]
📄 gpgconf
[E]
[D]
[R]
📄 gpgparsemail
[E]
[D]
[R]
📄 gpgsplit
[E]
[D]
[R]
📄 gpgv
[E]
[D]
[R]
📄 gpgv2
[E]
[D]
[R]
📄 gpic
[E]
[D]
[R]
📄 gprof
[E]
[D]
[R]
📄 gr2fonttest
[E]
[D]
[R]
📄 grep
[E]
[D]
[R]
📄 gresource
[E]
[D]
[R]
📄 groff
[E]
[D]
[R]
📄 grops
[E]
[D]
[R]
📄 grotty
[E]
[D]
[R]
📄 groups
[E]
[D]
[R]
📄 growpart
[E]
[D]
[R]
📄 grub2-editenv
[E]
[D]
[R]
📄 grub2-file
[E]
[D]
[R]
📄 grub2-fstest
[E]
[D]
[R]
📄 grub2-glue-efi
[E]
[D]
[R]
📄 grub2-kbdcomp
[E]
[D]
[R]
📄 grub2-menulst2cfg
[E]
[D]
[R]
📄 grub2-mkfont
[E]
[D]
[R]
📄 grub2-mkimage
[E]
[D]
[R]
📄 grub2-mklayout
[E]
[D]
[R]
📄 grub2-mknetdir
[E]
[D]
[R]
📄 grub2-mkpasswd-pbkdf2
[E]
[D]
[R]
📄 grub2-mkrelpath
[E]
[D]
[R]
📄 grub2-mkrescue
[E]
[D]
[R]
📄 grub2-mkstandalone
[E]
[D]
[R]
📄 grub2-render-label
[E]
[D]
[R]
📄 grub2-script-check
[E]
[D]
[R]
📄 grub2-syslinux2cfg
[E]
[D]
[R]
📄 gsettings
[E]
[D]
[R]
📄 gsoelim
[E]
[D]
[R]
📄 gss-client
[E]
[D]
[R]
📄 gtar
[E]
[D]
[R]
📄 gtbl
[E]
[D]
[R]
📄 gtester
[E]
[D]
[R]
📄 gtester-report
[E]
[D]
[R]
📄 gtroff
[E]
[D]
[R]
📄 gunzip
[E]
[D]
[R]
📄 gzexe
[E]
[D]
[R]
📄 gzip
[E]
[D]
[R]
📄 h2ph
[E]
[D]
[R]
📄 h2xs
[E]
[D]
[R]
📄 has160-hash
[E]
[D]
[R]
📄 head
[E]
[D]
[R]
📄 hexdump
[E]
[D]
[R]
📄 hmac256
[E]
[D]
[R]
📄 host
[E]
[D]
[R]
📄 hostid
[E]
[D]
[R]
📄 hostname
[E]
[D]
[R]
📄 hostnamectl
[E]
[D]
[R]
📄 htdbm
[E]
[D]
[R]
📄 htdigest
[E]
[D]
[R]
📄 htpasswd
[E]
[D]
[R]
📄 httxt2dbm
[E]
[D]
[R]
📄 hunspell
[E]
[D]
[R]
📄 i386
[E]
[D]
[R]
📄 iceauth
[E]
[D]
[R]
📄 iconv
[E]
[D]
[R]
📄 icu-config
[E]
[D]
[R]
📄 icu-config-64
[E]
[D]
[R]
📄 icuinfo
[E]
[D]
[R]
📄 id
[E]
[D]
[R]
📄 identify
[E]
[D]
[R]
📄 idiag-socket-details
[E]
[D]
[R]
📄 idn
[E]
[D]
[R]
📄 ifnames
[E]
[D]
[R]
📄 igawk
[E]
[D]
[R]
📄 imapsync
[E]
[D]
[R]
📄 import
[E]
[D]
[R]
📄 info
[E]
[D]
[R]
📄 infocmp
[E]
[D]
[R]
📄 infokey
[E]
[D]
[R]
📄 infotocap
[E]
[D]
[R]
📄 innochecksum
[E]
[D]
[R]
📄 install
[E]
[D]
[R]
📄 instmodsh
[E]
[D]
[R]
📄 ionice
[E]
[D]
[R]
📄 iostat
[E]
[D]
[R]
📄 ipcalc
[E]
[D]
[R]
📄 ipcmk
[E]
[D]
[R]
📄 ipcrm
[E]
[D]
[R]
📄 ipcs
[E]
[D]
[R]
📄 iptables-xml
[E]
[D]
[R]
📄 isosize
[E]
[D]
[R]
📄 ispell
[E]
[D]
[R]
📄 jemalloc.sh
[E]
[D]
[R]
📄 jobs
[E]
[D]
[R]
📄 join
[E]
[D]
[R]
📄 journalctl
[E]
[D]
[R]
📄 jsonpointer
[E]
[D]
[R]
📄 kbd_mode
[E]
[D]
[R]
📄 kbdinfo
[E]
[D]
[R]
📄 kbdrate
[E]
[D]
[R]
📄 kdumpctl
[E]
[D]
[R]
📄 kernel-install
[E]
[D]
[R]
📄 keyrand
[E]
[D]
[R]
📄 keyutil
[E]
[D]
[R]
📄 kill
[E]
[D]
[R]
📄 killall
[E]
[D]
[R]
📄 kmod
[E]
[D]
[R]
📄 krb5-config
[E]
[D]
[R]
📄 l4p-tmpl
[E]
[D]
[R]
📄 last
[E]
[D]
[R]
📄 lastb
[E]
[D]
[R]
📄 lastlog
[E]
[D]
[R]
📄 lchfn
[E]
[D]
[R]
📄 lchsh
[E]
[D]
[R]
📄 ld
[E]
[D]
[R]
📄 ld.bfd
[E]
[D]
[R]
📄 ld.gold
[E]
[D]
[R]
📄 ldd
[E]
[D]
[R]
📄 less
[E]
[D]
[R]
📄 lessecho
[E]
[D]
[R]
📄 lesskey
[E]
[D]
[R]
📄 lesspipe.sh
[E]
[D]
[R]
📄 lex
[E]
[D]
[R]
📄 lexgrog
[E]
[D]
[R]
📄 libgcrypt-config
[E]
[D]
[R]
📄 libmcrypt-config
[E]
[D]
[R]
📄 libnetcfg
[E]
[D]
[R]
📄 libpng-config
[E]
[D]
[R]
📄 libpng15-config
[E]
[D]
[R]
📄 link
[E]
[D]
[R]
📄 links
[E]
[D]
[R]
📄 links2
[E]
[D]
[R]
📄 linux-boot-prober
[E]
[D]
[R]
📄 linux32
[E]
[D]
[R]
📄 linux64
[E]
[D]
[R]
📄 ln
[E]
[D]
[R]
📄 loadkeys
[E]
[D]
[R]
📄 loadunimap
[E]
[D]
[R]
📄 locale
[E]
[D]
[R]
📄 localectl
[E]
[D]
[R]
📄 localedef
[E]
[D]
[R]
📄 locate
[E]
[D]
[R]
📄 lockfile
[E]
[D]
[R]
📄 logger
[E]
[D]
[R]
📄 login
[E]
[D]
[R]
📄 loginctl
[E]
[D]
[R]
📄 logname
[E]
[D]
[R]
📄 logresolve
[E]
[D]
[R]
📄 look
[E]
[D]
[R]
📄 ls
[E]
[D]
[R]
📄 lsattr
[E]
[D]
[R]
📄 lsblk
[E]
[D]
[R]
📄 lscpu
[E]
[D]
[R]
📄 lsinitrd
[E]
[D]
[R]
📄 lsipc
[E]
[D]
[R]
📄 lslocks
[E]
[D]
[R]
📄 lslogins
[E]
[D]
[R]
📄 lsmem
[E]
[D]
[R]
📄 lsns
[E]
[D]
[R]
📄 lua
[E]
[D]
[R]
📄 luac
[E]
[D]
[R]
📄 lwp-download
[E]
[D]
[R]
📄 lwp-dump
[E]
[D]
[R]
📄 lwp-mirror
[E]
[D]
[R]
📄 lwp-request
[E]
[D]
[R]
📄 lz4
[E]
[D]
[R]
📄 lz4c
[E]
[D]
[R]
📄 lz4cat
[E]
[D]
[R]
📄 lzop
[E]
[D]
[R]
📄 m4
[E]
[D]
[R]
📄 machinectl
[E]
[D]
[R]
📄 magnet-link
[E]
[D]
[R]
📄 mailq
[E]
[D]
[R]
📄 mailq.postfix
[E]
[D]
[R]
📄 mailstat
[E]
[D]
[R]
📄 make
[E]
[D]
[R]
📄 makeconv
[E]
[D]
[R]
📄 makedb
[E]
[D]
[R]
📄 man
[E]
[D]
[R]
📄 mandb
[E]
[D]
[R]
📄 manpath
[E]
[D]
[R]
📄 mapscrn
[E]
[D]
[R]
📄 mariadb-service-convert
[E]
[D]
[R]
📄 mariadb_config
[E]
[D]
[R]
📄 mcookie
[E]
[D]
[R]
📄 md5sum
[E]
[D]
[R]
📄 mdig
[E]
[D]
[R]
📄 melt
[E]
[D]
[R]
📄 mesg
[E]
[D]
[R]
📄 mimedump
[E]
[D]
[R]
📄 mimeencode
[E]
[D]
[R]
📄 mimeexplode
[E]
[D]
[R]
📄 mimepostcard
[E]
[D]
[R]
📄 mimesend
[E]
[D]
[R]
📄 miniterm.py
[E]
[D]
[R]
📄 mkdir
[E]
[D]
[R]
📄 mkfifo
[E]
[D]
[R]
📄 mkfontdir
[E]
[D]
[R]
📄 mkfontscale
[E]
[D]
[R]
📄 mkinitrd
[E]
[D]
[R]
📄 mknod
[E]
[D]
[R]
📄 mktemp
[E]
[D]
[R]
📄 modutil
[E]
[D]
[R]
📄 mogrify
[E]
[D]
[R]
📄 montage
[E]
[D]
[R]
📄 more
[E]
[D]
[R]
📄 mount
[E]
[D]
[R]
📄 mountpoint
[E]
[D]
[R]
📄 mpstat
[E]
[D]
[R]
📄 msgattrib
[E]
[D]
[R]
📄 msgcat
[E]
[D]
[R]
📄 msgcmp
[E]
[D]
[R]
📄 msgcomm
[E]
[D]
[R]
📄 msgconv
[E]
[D]
[R]
📄 msgen
[E]
[D]
[R]
📄 msgexec
[E]
[D]
[R]
📄 msgfilter
[E]
[D]
[R]
📄 msgfmt
[E]
[D]
[R]
📄 msggrep
[E]
[D]
[R]
📄 msghack
[E]
[D]
[R]
📄 msginit
[E]
[D]
[R]
📄 msgmerge
[E]
[D]
[R]
📄 msgunfmt
[E]
[D]
[R]
📄 msguniq
[E]
[D]
[R]
📄 msql2mysql
[E]
[D]
[R]
📄 mv
[E]
[D]
[R]
📄 my_print_defaults
[E]
[D]
[R]
📄 myisam_ftdump
[E]
[D]
[R]
📄 myisamchk
[E]
[D]
[R]
📄 myisamlog
[E]
[D]
[R]
📄 myisampack
[E]
[D]
[R]
📄 mysql
[E]
[D]
[R]
📄 mysql_config
[E]
[D]
[R]
📄 mysql_convert_table_format
[E]
[D]
[R]
📄 mysql_embedded
[E]
[D]
[R]
📄 mysql_find_rows
[E]
[D]
[R]
📄 mysql_fix_extensions
[E]
[D]
[R]
📄 mysql_install_db
[E]
[D]
[R]
📄 mysql_plugin
[E]
[D]
[R]
📄 mysql_secure_installation
[E]
[D]
[R]
📄 mysql_setpermission
[E]
[D]
[R]
📄 mysql_tzinfo_to_sql
[E]
[D]
[R]
📄 mysql_upgrade
[E]
[D]
[R]
📄 mysql_waitpid
[E]
[D]
[R]
📄 mysql_zap
[E]
[D]
[R]
📄 mysqlaccess
[E]
[D]
[R]
📄 mysqladmin
[E]
[D]
[R]
📄 mysqlbinlog
[E]
[D]
[R]
📄 mysqlbug
[E]
[D]
[R]
📄 mysqlcheck
[E]
[D]
[R]
📄 mysqld_multi
[E]
[D]
[R]
📄 mysqld_safe
[E]
[D]
[R]
📄 mysqld_safe_helper
[E]
[D]
[R]
📄 mysqldump
[E]
[D]
[R]
📄 mysqldumpslow
[E]
[D]
[R]
📄 mysqlhotcopy
[E]
[D]
[R]
📄 mysqlimport
[E]
[D]
[R]
📄 mysqlshow
[E]
[D]
[R]
📄 mysqlslap
[E]
[D]
[R]
📄 named-rrchecker
[E]
[D]
[R]
📄 namei
[E]
[D]
[R]
📄 nano
[E]
[D]
[R]
📄 ncurses5-config
[E]
[D]
[R]
📄 ncursesw5-config
[E]
[D]
[R]
📄 ndptool
[E]
[D]
[R]
📄 needs-restarting
[E]
[D]
[R]
📄 neqn
[E]
[D]
[R]
📄 net-server
[E]
[D]
[R]
📄 net-snmp-config
[E]
[D]
[R]
📄 net-snmp-config-x86_64
[E]
[D]
[R]
📄 net-snmp-create-v3-user
[E]
[D]
[R]
📄 netstat
[E]
[D]
[R]
📄 nettle-hash
[E]
[D]
[R]
📄 nettle-lfib-stream
[E]
[D]
[R]
📄 newaliases
[E]
[D]
[R]
📄 newaliases.postfix
[E]
[D]
[R]
📄 newgidmap
[E]
[D]
[R]
📄 newgrp
[E]
[D]
[R]
📄 newuidmap
[E]
[D]
[R]
📄 nf-ct-add
[E]
[D]
[R]
📄 nf-ct-list
[E]
[D]
[R]
📄 nf-exp-add
[E]
[D]
[R]
📄 nf-exp-delete
[E]
[D]
[R]
📄 nf-exp-list
[E]
[D]
[R]
📄 nf-log
[E]
[D]
[R]
📄 nf-monitor
[E]
[D]
[R]
📄 nf-queue
[E]
[D]
[R]
📄 nfsiostat-sysstat
[E]
[D]
[R]
📄 ngettext
[E]
[D]
[R]
📄 nice
[E]
[D]
[R]
📄 nisdomainname
[E]
[D]
[R]
📄 nl
[E]
[D]
[R]
📄 nl-addr-add
[E]
[D]
[R]
📄 nl-addr-delete
[E]
[D]
[R]
📄 nl-addr-list
[E]
[D]
[R]
📄 nl-class-add
[E]
[D]
[R]
📄 nl-class-delete
[E]
[D]
[R]
📄 nl-class-list
[E]
[D]
[R]
📄 nl-classid-lookup
[E]
[D]
[R]
📄 nl-cls-add
[E]
[D]
[R]
📄 nl-cls-delete
[E]
[D]
[R]
📄 nl-cls-list
[E]
[D]
[R]
📄 nl-fib-lookup
[E]
[D]
[R]
📄 nl-link-enslave
[E]
[D]
[R]
📄 nl-link-ifindex2name
[E]
[D]
[R]
📄 nl-link-list
[E]
[D]
[R]
📄 nl-link-name2ifindex
[E]
[D]
[R]
📄 nl-link-release
[E]
[D]
[R]
📄 nl-link-set
[E]
[D]
[R]
📄 nl-link-stats
[E]
[D]
[R]
📄 nl-list-caches
[E]
[D]
[R]
📄 nl-list-sockets
[E]
[D]
[R]
📄 nl-monitor
[E]
[D]
[R]
📄 nl-neigh-add
[E]
[D]
[R]
📄 nl-neigh-delete
[E]
[D]
[R]
📄 nl-neigh-list
[E]
[D]
[R]
📄 nl-neightbl-list
[E]
[D]
[R]
📄 nl-pktloc-lookup
[E]
[D]
[R]
📄 nl-qdisc-add
[E]
[D]
[R]
📄 nl-qdisc-delete
[E]
[D]
[R]
📄 nl-qdisc-list
[E]
[D]
[R]
📄 nl-route-add
[E]
[D]
[R]
📄 nl-route-delete
[E]
[D]
[R]
📄 nl-route-get
[E]
[D]
[R]
📄 nl-route-list
[E]
[D]
[R]
📄 nl-rule-list
[E]
[D]
[R]
📄 nl-tctree-list
[E]
[D]
[R]
📄 nl-util-addr
[E]
[D]
[R]
📄 nm
[E]
[D]
[R]
📄 nohup
[E]
[D]
[R]
📄 nomarch
[E]
[D]
[R]
📄 nproc
[E]
[D]
[R]
📄 nroff
[E]
[D]
[R]
📄 nsenter
[E]
[D]
[R]
📄 nslookup
[E]
[D]
[R]
📄 nss-policy-check
[E]
[D]
[R]
📄 nsupdate
[E]
[D]
[R]
📄 numfmt
[E]
[D]
[R]
📄 objcopy
[E]
[D]
[R]
📄 objdump
[E]
[D]
[R]
📄 od
[E]
[D]
[R]
📄 offlineimap
[E]
[D]
[R]
📄 oldfind
[E]
[D]
[R]
📄 onig-config
[E]
[D]
[R]
📄 opax
[E]
[D]
[R]
📄 open
[E]
[D]
[R]
📄 openssl
[E]
[D]
[R]
📄 openvt
[E]
[D]
[R]
📄 os-prober
[E]
[D]
[R]
📄 p11-kit
[E]
[D]
[R]
📄 package-cleanup
[E]
[D]
[R]
📄 package-stash-conflicts
[E]
[D]
[R]
📄 page_owner_sort
[E]
[D]
[R]
📄 pango-list
[E]
[D]
[R]
📄 pango-querymodules-64
[E]
[D]
[R]
📄 pango-view
[E]
[D]
[R]
📄 paperconf
[E]
[D]
[R]
📄 passwd
[E]
[D]
[R]
📄 paste
[E]
[D]
[R]
📄 pathchk
[E]
[D]
[R]
📄 pax
[E]
[D]
[R]
📄 pchrt
[E]
[D]
[R]
📄 pcre-config
[E]
[D]
[R]
📄 peekfd
[E]
[D]
[R]
📄 perl
[E]
[D]
[R]
📄 perl5.16.3
[E]
[D]
[R]
📄 perlbug
[E]
[D]
[R]
📄 perldoc
[E]
[D]
[R]
📄 perlivp
[E]
[D]
[R]
📄 perlthanks
[E]
[D]
[R]
📄 perror
[E]
[D]
[R]
📄 pflags
[E]
[D]
[R]
📄 pg_config
[E]
[D]
[R]
📄 pg_dump
[E]
[D]
[R]
📄 pg_dumpall
[E]
[D]
[R]
📄 pg_restore
[E]
[D]
[R]
📄 pgawk
[E]
[D]
[R]
📄 pgrep
[E]
[D]
[R]
📄 php
[E]
[D]
[R]
📄 pic
[E]
[D]
[R]
📄 piconv
[E]
[D]
[R]
📄 pidstat
[E]
[D]
[R]
📄 pinentry
[E]
[D]
[R]
📄 pinentry-curses
[E]
[D]
[R]
📄 ping
[E]
[D]
[R]
📄 ping6
[E]
[D]
[R]
📄 pinky
[E]
[D]
[R]
📄 pip-3
[E]
[D]
[R]
📄 pip-3.6
[E]
[D]
[R]
📄 pip3
[E]
[D]
[R]
📄 pip3.6
[E]
[D]
[R]
📄 pk12util
[E]
[D]
[R]
📄 pkaction
[E]
[D]
[R]
📄 pkcheck
[E]
[D]
[R]
📄 pkcs1-conv
[E]
[D]
[R]
📄 pkexec
[E]
[D]
[R]
📄 pkg-config
[E]
[D]
[R]
📄 pkgdata
[E]
[D]
[R]
📄 pkill
[E]
[D]
[R]
📄 pkla-admin-identities
[E]
[D]
[R]
📄 pkla-check-authorization
[E]
[D]
[R]
📄 pkttyagent
[E]
[D]
[R]
📄 pl2pm
[E]
[D]
[R]
📄 pldd
[E]
[D]
[R]
📄 pmap
[E]
[D]
[R]
📄 pod2html
[E]
[D]
[R]
📄 pod2man
[E]
[D]
[R]
📄 pod2text
[E]
[D]
[R]
📄 pod2usage
[E]
[D]
[R]
📄 post-grohtml
[E]
[D]
[R]
📄 powernow-k8-decode
[E]
[D]
[R]
📄 pr
[E]
[D]
[R]
📄 pre-grohtml
[E]
[D]
[R]
📄 precat
[E]
[D]
[R]
📄 preconv
[E]
[D]
[R]
📄 preunzip
[E]
[D]
[R]
📄 prezip
[E]
[D]
[R]
📄 prezip-bin
[E]
[D]
[R]
📄 printenv
[E]
[D]
[R]
📄 printf
[E]
[D]
[R]
📄 prlimit
[E]
[D]
[R]
📄 procmail
[E]
[D]
[R]
📄 prove
[E]
[D]
[R]
📄 prtstat
[E]
[D]
[R]
📄 ps
[E]
[D]
[R]
📄 psed
[E]
[D]
[R]
📄 psfaddtable
[E]
[D]
[R]
📄 psfgettable
[E]
[D]
[R]
📄 psfstriptable
[E]
[D]
[R]
📄 psfxtable
[E]
[D]
[R]
📄 pspell-config
[E]
[D]
[R]
📄 psql
[E]
[D]
[R]
📄 pstree
[E]
[D]
[R]
📄 pstree.x11
[E]
[D]
[R]
📄 pstruct
[E]
[D]
[R]
📄 ptar
[E]
[D]
[R]
📄 ptardiff
[E]
[D]
[R]
📄 ptargrep
[E]
[D]
[R]
📄 ptaskset
[E]
[D]
[R]
📄 ptx
[E]
[D]
[R]
📄 pure-ftpwho
[E]
[D]
[R]
📄 pure-pw
[E]
[D]
[R]
📄 pure-pwconvert
[E]
[D]
[R]
📄 pure-statsdecode
[E]
[D]
[R]
📄 pwd
[E]
[D]
[R]
📄 pwdx
[E]
[D]
[R]
📄 pwmake
[E]
[D]
[R]
📄 pwscore
[E]
[D]
[R]
📄 pydoc
[E]
[D]
[R]
📄 pydoc3
[E]
[D]
[R]
📄 pydoc3.6
[E]
[D]
[R]
📄 python
[E]
[D]
[R]
📄 python2
[E]
[D]
[R]
📄 python2.7
[E]
[D]
[R]
📄 python3
[E]
[D]
[R]
📄 python3.6
[E]
[D]
[R]
📄 python3.6m
[E]
[D]
[R]
📄 pyvenv
[E]
[D]
[R]
📄 pyvenv-3.6
[E]
[D]
[R]
📄 qemu-ga
[E]
[D]
[R]
📄 quota
[E]
[D]
[R]
📄 quotasync
[E]
[D]
[R]
📄 ranlib
[E]
[D]
[R]
📄 raw
[E]
[D]
[R]
📄 razor-admin
[E]
[D]
[R]
📄 razor-check
[E]
[D]
[R]
📄 razor-client
[E]
[D]
[R]
📄 razor-report
[E]
[D]
[R]
📄 razor-revoke
[E]
[D]
[R]
📄 read
[E]
[D]
[R]
📄 readelf
[E]
[D]
[R]
📄 readlink
[E]
[D]
[R]
📄 realpath
[E]
[D]
[R]
📄 rearj
[E]
[D]
[R]
📄 recode
[E]
[D]
[R]
📄 recode-sr-latin
[E]
[D]
[R]
📄 reindexdb
[E]
[D]
[R]
📄 rename
[E]
[D]
[R]
📄 renice
[E]
[D]
[R]
📄 replace
[E]
[D]
[R]
📄 repo-graph
[E]
[D]
[R]
📄 repo-rss
[E]
[D]
[R]
📄 repoclosure
[E]
[D]
[R]
📄 repodiff
[E]
[D]
[R]
📄 repomanage
[E]
[D]
[R]
📄 repoquery
[E]
[D]
[R]
📄 reposync
[E]
[D]
[R]
📄 repotrack
[E]
[D]
[R]
📄 reset
[E]
[D]
[R]
📄 resizecons
[E]
[D]
[R]
📄 resolve_stack_dump
[E]
[D]
[R]
📄 resolveip
[E]
[D]
[R]
📄 rev
[E]
[D]
[R]
📄 rhash
[E]
[D]
[R]
📄 rm
[E]
[D]
[R]
📄 rmail
[E]
[D]
[R]
📄 rmail.postfix
[E]
[D]
[R]
📄 rmdir
[E]
[D]
[R]
📄 rnano
[E]
[D]
[R]
📄 rpcgen
[E]
[D]
[R]
📄 rpm
[E]
[D]
[R]
📄 rpm2cpio
[E]
[D]
[R]
📄 rpmdb
[E]
[D]
[R]
📄 rpmgraph
[E]
[D]
[R]
📄 rpmkeys
[E]
[D]
[R]
📄 rpmquery
[E]
[D]
[R]
📄 rpmverify
[E]
[D]
[R]
📄 rrdcached
[E]
[D]
[R]
📄 rrdcgi
[E]
[D]
[R]
📄 rrdcreate
[E]
[D]
[R]
📄 rrdinfo
[E]
[D]
[R]
📄 rrdtool
[E]
[D]
[R]
📄 rrdupdate
[E]
[D]
[R]
📄 rsync
[E]
[D]
[R]
📄 rsyslog-recover-qi.pl
[E]
[D]
[R]
📄 run-parts
[E]
[D]
[R]
📄 run-with-aspell
[E]
[D]
[R]
📄 runcon
[E]
[D]
[R]
📄 rvi
[E]
[D]
[R]
📄 rview
[E]
[D]
[R]
📄 s2p
[E]
[D]
[R]
📄 sa-awl
[E]
[D]
[R]
📄 sa-check_spamd
[E]
[D]
[R]
📄 sa-compile
[E]
[D]
[R]
📄 sa-learn
[E]
[D]
[R]
📄 sa-update
[E]
[D]
[R]
📄 sadf
[E]
[D]
[R]
📄 sandbox
[E]
[D]
[R]
📄 sar
[E]
[D]
[R]
📄 sasl2-sample-client
[E]
[D]
[R]
📄 sasl2-sample-server
[E]
[D]
[R]
📄 scp
[E]
[D]
[R]
📄 screen
[E]
[D]
[R]
📄 script
[E]
[D]
[R]
📄 scriptreplay
[E]
[D]
[R]
📄 sdiff
[E]
[D]
[R]
📄 secon
[E]
[D]
[R]
📄 sed
[E]
[D]
[R]
📄 sedismod
[E]
[D]
[R]
📄 sedispol
[E]
[D]
[R]
📄 semodule_package
[E]
[D]
[R]
📄 seq
[E]
[D]
[R]
📄 sessreg
[E]
[D]
[R]
📄 setarch
[E]
[D]
[R]
📄 setfacl
[E]
[D]
[R]
📄 setfont
[E]
[D]
[R]
📄 setkeycodes
[E]
[D]
[R]
📄 setleds
[E]
[D]
[R]
📄 setmetamode
[E]
[D]
[R]
📄 setpriv
[E]
[D]
[R]
📄 setsid
[E]
[D]
[R]
📄 setterm
[E]
[D]
[R]
📄 setup-nsssysinit
[E]
[D]
[R]
📄 setup-nsssysinit.sh
[E]
[D]
[R]
📄 setvtrgb
[E]
[D]
[R]
📄 sexp-conv
[E]
[D]
[R]
📄 sftp
[E]
[D]
[R]
📄 sfv-hash
[E]
[D]
[R]
📄 sg
[E]
[D]
[R]
📄 sh
[E]
[D]
[R]
📄 sha1sum
[E]
[D]
[R]
📄 sha224sum
[E]
[D]
[R]
📄 sha256sum
[E]
[D]
[R]
📄 sha384sum
[E]
[D]
[R]
📄 sha512sum
[E]
[D]
[R]
📄 shasum
[E]
[D]
[R]
📄 show-changed-rco
[E]
[D]
[R]
📄 show-installed
[E]
[D]
[R]
📄 showconsolefont
[E]
[D]
[R]
📄 showkey
[E]
[D]
[R]
📄 showrgb
[E]
[D]
[R]
📄 shred
[E]
[D]
[R]
📄 shuf
[E]
[D]
[R]
📄 sieve-dump
[E]
[D]
[R]
📄 sieve-filter
[E]
[D]
[R]
📄 sieve-test
[E]
[D]
[R]
📄 sievec
[E]
[D]
[R]
📄 signver
[E]
[D]
[R]
📄 sigtool
[E]
[D]
[R]
📄 sim_client
[E]
[D]
[R]
📄 size
[E]
[D]
[R]
📄 skill
[E]
[D]
[R]
📄 slabinfo
[E]
[D]
[R]
📄 slabtop
[E]
[D]
[R]
📄 sleep
[E]
[D]
[R]
📄 slogin
[E]
[D]
[R]
📄 snice
[E]
[D]
[R]
📄 snmpconf
[E]
[D]
[R]
📄 soelim
[E]
[D]
[R]
📄 sort
[E]
[D]
[R]
📄 sotruss
[E]
[D]
[R]
📄 spamassassin
[E]
[D]
[R]
📄 spamc
[E]
[D]
[R]
📄 spamd
[E]
[D]
[R]
📄 spell
[E]
[D]
[R]
📄 splain
[E]
[D]
[R]
📄 split
[E]
[D]
[R]
📄 sprof
[E]
[D]
[R]
📄 sqlite3
[E]
[D]
[R]
📄 ssh
[E]
[D]
[R]
📄 ssh-add
[E]
[D]
[R]
📄 ssh-agent
[E]
[D]
[R]
📄 ssh-copy-id
[E]
[D]
[R]
📄 ssh-keygen
[E]
[D]
[R]
📄 ssh-keyscan
[E]
[D]
[R]
📄 ssltap
[E]
[D]
[R]
📄 stat
[E]
[D]
[R]
📄 statist
[E]
[D]
[R]
📄 stdbuf
[E]
[D]
[R]
📄 stream
[E]
[D]
[R]
📄 strings
[E]
[D]
[R]
📄 strip
[E]
[D]
[R]
📄 stty
[E]
[D]
[R]
📄 su
[E]
[D]
[R]
📄 sudo
[E]
[D]
[R]
📄 sudoedit
[E]
[D]
[R]
📄 sudoreplay
[E]
[D]
[R]
📄 sum
[E]
[D]
[R]
📄 svn
[E]
[D]
[R]
📄 svnadmin
[E]
[D]
[R]
📄 svndumpfilter
[E]
[D]
[R]
📄 svnlook
[E]
[D]
[R]
📄 svnrdump
[E]
[D]
[R]
📄 svnserve
[E]
[D]
[R]
📄 svnsync
[E]
[D]
[R]
📄 svnversion
[E]
[D]
[R]
📄 sxpm
[E]
[D]
[R]
📄 sync
[E]
[D]
[R]
📄 systemctl
[E]
[D]
[R]
📄 systemd-analyze
[E]
[D]
[R]
📄 systemd-ask-password
[E]
[D]
[R]
📄 systemd-cat
[E]
[D]
[R]
📄 systemd-cgls
[E]
[D]
[R]
📄 systemd-cgtop
[E]
[D]
[R]
📄 systemd-coredumpctl
[E]
[D]
[R]
📄 systemd-delta
[E]
[D]
[R]
📄 systemd-detect-virt
[E]
[D]
[R]
📄 systemd-escape
[E]
[D]
[R]
📄 systemd-firstboot
[E]
[D]
[R]
📄 systemd-hwdb
[E]
[D]
[R]
📄 systemd-inhibit
[E]
[D]
[R]
📄 systemd-loginctl
[E]
[D]
[R]
📄 systemd-machine-id-setup
[E]
[D]
[R]
📄 systemd-notify
[E]
[D]
[R]
📄 systemd-nspawn
[E]
[D]
[R]
📄 systemd-path
[E]
[D]
[R]
📄 systemd-run
[E]
[D]
[R]
📄 systemd-stdio-bridge
[E]
[D]
[R]
📄 systemd-sysv-convert
[E]
[D]
[R]
📄 systemd-tmpfiles
[E]
[D]
[R]
📄 systemd-tty-ask-password-agent
[E]
[D]
[R]
📄 tabs
[E]
[D]
[R]
📄 tac
[E]
[D]
[R]
📄 tail
[E]
[D]
[R]
📄 tailf
[E]
[D]
[R]
📄 tapestat
[E]
[D]
[R]
📄 tar
[E]
[D]
[R]
📄 taskset
[E]
[D]
[R]
📄 tbl
[E]
[D]
[R]
📄 tcamgr
[E]
[D]
[R]
📄 tcamttest
[E]
[D]
[R]
📄 tcatest
[E]
[D]
[R]
📄 tcbmgr
[E]
[D]
[R]
📄 tcbmttest
[E]
[D]
[R]
📄 tcbtest
[E]
[D]
[R]
📄 tcfmgr
[E]
[D]
[R]
📄 tcfmttest
[E]
[D]
[R]
📄 tcftest
[E]
[D]
[R]
📄 tchmgr
[E]
[D]
[R]
📄 tchmttest
[E]
[D]
[R]
📄 tchtest
[E]
[D]
[R]
📄 tctmgr
[E]
[D]
[R]
📄 tctmttest
[E]
[D]
[R]
📄 tcttest
[E]
[D]
[R]
📄 tcucodec
[E]
[D]
[R]
📄 tcumttest
[E]
[D]
[R]
📄 tcutest
[E]
[D]
[R]
📄 teamd
[E]
[D]
[R]
📄 teamdctl
[E]
[D]
[R]
📄 teamnl
[E]
[D]
[R]
📄 tee
[E]
[D]
[R]
📄 test
[E]
[D]
[R]
📄 testgdbm
[E]
[D]
[R]
📄 tic
[E]
[D]
[R]
📄 tiger-hash
[E]
[D]
[R]
📄 timedatectl
[E]
[D]
[R]
📄 timeout
[E]
[D]
[R]
📄 tload
[E]
[D]
[R]
📄 tmon
[E]
[D]
[R]
📄 tmpwatch
[E]
[D]
[R]
📄 toe
[E]
[D]
[R]
📄 tokuft_logprint
[E]
[D]
[R]
📄 tokuftdump
[E]
[D]
[R]
📄 top
[E]
[D]
[R]
📄 touch
[E]
[D]
[R]
📄 tput
[E]
[D]
[R]
📄 tr
[E]
[D]
[R]
📄 tracepath
[E]
[D]
[R]
📄 tracepath6
[E]
[D]
[R]
📄 troff
[E]
[D]
[R]
📄 true
[E]
[D]
[R]
📄 truncate
[E]
[D]
[R]
📄 trust
[E]
[D]
[R]
📄 tset
[E]
[D]
[R]
📄 tsort
[E]
[D]
[R]
📄 tth-hash
[E]
[D]
[R]
📄 tty
[E]
[D]
[R]
📄 turbostat
[E]
[D]
[R]
📄 tzselect
[E]
[D]
[R]
📄 uconv
[E]
[D]
[R]
📄 ucs2any
[E]
[D]
[R]
📄 udevadm
[E]
[D]
[R]
📄 ul
[E]
[D]
[R]
📄 umask
[E]
[D]
[R]
📄 umount
[E]
[D]
[R]
📄 unalias
[E]
[D]
[R]
📄 uname
[E]
[D]
[R]
📄 unarj
[E]
[D]
[R]
📄 unexpand
[E]
[D]
[R]
📄 unfreeze
[E]
[D]
[R]
📄 unicode_start
[E]
[D]
[R]
📄 unicode_stop
[E]
[D]
[R]
📄 uniq
[E]
[D]
[R]
📄 unlink
[E]
[D]
[R]
📄 unlz4
[E]
[D]
[R]
📄 unshare
[E]
[D]
[R]
📄 unxz
[E]
[D]
[R]
📄 unzip
[E]
[D]
[R]
📄 unzipsfx
[E]
[D]
[R]
📄 unzoo
[E]
[D]
[R]
📄 update-ca-trust
[E]
[D]
[R]
📄 update-mime-database
[E]
[D]
[R]
📄 updatedb
[E]
[D]
[R]
📄 uptime
[E]
[D]
[R]
📄 urlgrabber
[E]
[D]
[R]
📄 users
[E]
[D]
[R]
📄 usleep
[E]
[D]
[R]
📄 utmpdump
[E]
[D]
[R]
📄 uuclient
[E]
[D]
[R]
📄 uuidgen
[E]
[D]
[R]
📄 vacuumdb
[E]
[D]
[R]
📄 vdir
[E]
[D]
[R]
📄 verifytree
[E]
[D]
[R]
📄 vi
[E]
[D]
[R]
📄 view
[E]
[D]
[R]
📄 vlock
[E]
[D]
[R]
📄 vmstat
[E]
[D]
[R]
📄 w
[E]
[D]
[R]
📄 wait
[E]
[D]
[R]
📄 wall
[E]
[D]
[R]
📄 watch
[E]
[D]
[R]
📄 watchgnupg
[E]
[D]
[R]
📄 wc
[E]
[D]
[R]
📄 wdctl
[E]
[D]
[R]
📄 wget
[E]
[D]
[R]
📄 whatis
[E]
[D]
[R]
📄 whereis
[E]
[D]
[R]
📄 which
[E]
[D]
[R]
📄 whiptail
[E]
[D]
[R]
📄 whirlpool-hash
[E]
[D]
[R]
📄 who
[E]
[D]
[R]
📄 whoami
[E]
[D]
[R]
📄 word-list-compress
[E]
[D]
[R]
📄 write
[E]
[D]
[R]
📄 wsrep_sst_common
[E]
[D]
[R]
📄 wsrep_sst_mariabackup
[E]
[D]
[R]
📄 wsrep_sst_mysqldump
[E]
[D]
[R]
📄 wsrep_sst_rsync
[E]
[D]
[R]
📄 wsrep_sst_rsync_wan
[E]
[D]
[R]
📄 wsrep_sst_xtrabackup
[E]
[D]
[R]
📄 wsrep_sst_xtrabackup-v2
[E]
[D]
[R]
📄 x86_64
[E]
[D]
[R]
📄 x86_64-redhat-linux-c++
[E]
[D]
[R]
📄 x86_64-redhat-linux-g++
[E]
[D]
[R]
📄 x86_64-redhat-linux-gcc
[E]
[D]
[R]
📄 x86_energy_perf_policy
[E]
[D]
[R]
📄 xargs
[E]
[D]
[R]
📄 xgamma
[E]
[D]
[R]
📄 xgettext
[E]
[D]
[R]
📄 xhost
[E]
[D]
[R]
📄 xinput
[E]
[D]
[R]
📄 xkill
[E]
[D]
[R]
📄 xml2-config
[E]
[D]
[R]
📄 xmlcatalog
[E]
[D]
[R]
📄 xmllint
[E]
[D]
[R]
📄 xmlwf
[E]
[D]
[R]
📄 xmodmap
[E]
[D]
[R]
📄 xorg-x11-fonts-update-dirs
[E]
[D]
[R]
📄 xrandr
[E]
[D]
[R]
📄 xrdb
[E]
[D]
[R]
📄 xrefresh
[E]
[D]
[R]
📄 xset
[E]
[D]
[R]
📄 xsetmode
[E]
[D]
[R]
📄 xsetpointer
[E]
[D]
[R]
📄 xsetroot
[E]
[D]
[R]
📄 xslt-config
[E]
[D]
[R]
📄 xsltproc
[E]
[D]
[R]
📄 xstdcmap
[E]
[D]
[R]
📄 xsubpp
[E]
[D]
[R]
📄 xz
[E]
[D]
[R]
📄 xzcat
[E]
[D]
[R]
📄 xzcmp
[E]
[D]
[R]
📄 xzdec
[E]
[D]
[R]
📄 xzdiff
[E]
[D]
[R]
📄 xzegrep
[E]
[D]
[R]
📄 xzfgrep
[E]
[D]
[R]
📄 xzgrep
[E]
[D]
[R]
📄 xzless
[E]
[D]
[R]
📄 xzmore
[E]
[D]
[R]
📄 yes
[E]
[D]
[R]
📄 ypdomainname
[E]
[D]
[R]
📄 yum
[E]
[D]
[R]
📄 yum-builddep
[E]
[D]
[R]
📄 yum-config-manager
[E]
[D]
[R]
📄 yum-debug-dump
[E]
[D]
[R]
📄 yum-debug-restore
[E]
[D]
[R]
📄 yum-groups-manager
[E]
[D]
[R]
📄 yumdownloader
[E]
[D]
[R]
📄 zcat
[E]
[D]
[R]
📄 zcmp
[E]
[D]
[R]
📄 zdiff
[E]
[D]
[R]
📄 zegrep
[E]
[D]
[R]
📄 zfgrep
[E]
[D]
[R]
📄 zforce
[E]
[D]
[R]
📄 zgrep
[E]
[D]
[R]
📄 zip
[E]
[D]
[R]
📄 zipcloak
[E]
[D]
[R]
📄 zipdetails
[E]
[D]
[R]
📄 zipgrep
[E]
[D]
[R]
📄 zipinfo
[E]
[D]
[R]
📄 zipnote
[E]
[D]
[R]
📄 zipsplit
[E]
[D]
[R]
📄 zless
[E]
[D]
[R]
📄 zmore
[E]
[D]
[R]
📄 znew
[E]
[D]
[R]
📄 zsoelim
[E]
[D]
[R]
Editing: mysqld_safe
#!/bin/sh # Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB # This file is public domain and comes with NO WARRANTY of any kind # # Script to start the MySQL daemon and restart it if it dies unexpectedly # # This should be executed in the MySQL base directory if you are using a # binary installation that is not installed in its compile-time default # location # # mysql.server works by first doing a cd to the base directory and from there # executing mysqld_safe # Initialize script globals KILL_MYSQLD=1; MYSQLD= niceness=0 nowatch=0 mysqld_ld_preload= mysqld_ld_library_path= flush_caches=0 numa_interleave=0 unsafe_my_cnf=0 wsrep_on=0 dry_run=0 defaults_group_suffix= # Initial logging status: error log is not open, and not using syslog logging=init want_syslog=0 syslog_tag= user='mysql' pid_file= err_log= err_log_base= skip_err_log=0 syslog_tag_mysqld=mysqld syslog_tag_mysqld_safe=mysqld_safe trap '' 1 2 3 15 # we shouldn't let anyone kill us # MySQL-specific environment variable. First off, it's not really a umask, # it's the desired mode. Second, it follows umask(2), not umask(3) in that # octal needs to be explicit. Our shell might be a proper sh without printf, # multiple-base arithmetic, and binary arithmetic, so this will get ugly. # We reject decimal values to keep things at least half-sane. umask 007 # fallback UMASK="${UMASK-0640}" fmode=`echo "$UMASK" | sed -e 's/[^0246]//g'` octalp=`echo "$fmode"|cut -c1` fmlen=`echo "$fmode"|wc -c|sed -e 's/ //g'` if [ "x$octalp" != "x0" -o "x$UMASK" != "x$fmode" -o "x$fmlen" != "x5" ] then fmode=0640 echo "UMASK must be a 3-digit mode with an additional leading 0 to indicate octal." >&2 echo "The first digit will be corrected to 6, the others may be 0, 2, 4, or 6." >&2 fi fmode=`echo "$fmode"|cut -c3-4` fmode="6$fmode" if [ "x$UMASK" != "x0$fmode" ] then echo "UMASK corrected from $UMASK to 0$fmode ..." fi defaults= case "$1" in --no-defaults|--defaults-file=*|--defaults-extra-file=*) defaults="$1"; shift ;; esac usage () { cat <<EOF Usage: $0 [OPTIONS] --no-defaults Don't read the system defaults file --core-file-size=LIMIT Limit core files to the specified size --defaults-file=FILE Use the specified defaults file --defaults-extra-file=FILE Also use defaults from the specified file --ledir=DIRECTORY Look for mysqld in the specified directory --open-files-limit=LIMIT Limit the number of open files --crash-script=FILE Script to call when mysqld crashes --timezone=TZ Set the system timezone --malloc-lib=LIB Preload shared library LIB if available --mysqld=FILE Use the specified file as mysqld --mysqld-version=VERSION Use "mysqld-VERSION" as mysqld --dry-run Simulate the start to detect errors but don't start --nice=NICE Set the scheduling priority of mysqld --no-auto-restart Exit after starting mysqld --nowatch Exit after starting mysqld --plugin-dir=DIR Plugins are under DIR or DIR/VERSION, if VERSION is given --skip-kill-mysqld Don't try to kill stray mysqld processes --syslog Log messages to syslog with 'logger' --skip-syslog Log messages to error log (default) --syslog-tag=TAG Pass -t "mysqld-TAG" to 'logger' --flush-caches Flush and purge buffers/caches before starting the server --numa-interleave Run mysqld with its memory interleaved on all NUMA nodes All other options are passed to the mysqld program. EOF exit 1 } my_which () { save_ifs="${IFS-UNSET}" IFS=: ret=0 for file do for dir in $PATH do if [ -f "$dir/$file" ] then echo "$dir/$file" continue 2 fi done ret=1 #signal an error break done if [ "$save_ifs" = UNSET ] then unset IFS else IFS="$save_ifs" fi return $ret # Success } find_in_bin() { if test -x "$MY_BASEDIR_VERSION/bin/$1" then echo "$MY_BASEDIR_VERSION/bin/$1" elif test -x "/usr/bin/$1" then echo "/usr/bin/$1" else echo "$1" fi } log_generic () { [ $dry_run -eq 1 ] && return priority="$1" shift msg="`date +'%y%m%d %H:%M:%S'` mysqld_safe $*" echo "$msg" case $logging in init) ;; # Just echo the message, don't save it anywhere file) echo "$msg" | "$helper" "$user" log "$err_log" ;; syslog) logger -t "$syslog_tag_mysqld_safe" -p "$priority" "$*" ;; *) echo "Internal program error (non-fatal):" \ " unknown logging method '$logging'" >&2 ;; esac } log_error () { log_generic daemon.error "$@" >&2 } log_notice () { log_generic daemon.notice "$@" } eval_log_error () { local cmd="$1" case $logging in file) cmd="$cmd 2>&1 | "`shell_quote_string "$helper"`" $user log "`shell_quote_string "$err_log"` ;; syslog) # mysqld often prefixes its messages with a timestamp, which is # redundant when logging to syslog (which adds its own timestamp) # However, we don't strip the timestamp with sed here, because # sed buffers output (only GNU sed supports a -u (unbuffered) option) # which means that messages may not get sent to syslog until the # mysqld process quits. cmd="$cmd 2>&1 | logger -t '$syslog_tag_mysqld' -p daemon.error" ;; *) echo "Internal program error (non-fatal):" \ " unknown logging method '$logging'" >&2 ;; esac if test $nowatch -eq 1 then # We'd prefer to exec $cmd here, but SELinux needs to be fixed first #/usr/bin/logger "Running mysqld: $cmd" eval "$cmd &" exit 0 else #echo "Running mysqld: [$cmd]" eval "$cmd" fi } shell_quote_string() { # This sed command makes sure that any special chars are quoted, # so the arg gets passed exactly to the server. echo "$1" | sed -e 's,\([^a-zA-Z0-9/_.=-]\),\\\1,g' } wsrep_pick_url() { [ $# -eq 0 ] && return 0 log_error "WSREP: 'wsrep_urls' is DEPRECATED! Use wsrep_cluster_address to specify multiple addresses instead." if ! which nc >/dev/null; then log_error "ERROR: nc tool not found in PATH! Make sure you have it installed." return 1 fi local url # Assuming URL in the form scheme://host:port # If host and port are not NULL, the liveness of URL is assumed to be tested # If port part is absent, the url is returned literally and unconditionally # If every URL has port but none is reachable, nothing is returned for url in `echo $@ | sed s/,/\ /g` 0; do local host=`echo $url | cut -d \: -f 2 | sed s/^\\\/\\\///` local port=`echo $url | cut -d \: -f 3` [ -z "$port" ] && break nc -z "$host" $port >/dev/null && break done if [ "$url" == "0" ]; then log_error "ERROR: none of the URLs in '$@' is reachable." return 1 fi echo $url } # Run mysqld with --wsrep-recover and parse recovered position from log. # Position will be stored in wsrep_start_position_opt global. wsrep_start_position_opt="" wsrep_recover_position() { local mysqld_cmd="$@" local euid=$(id -u) local ret=0 local wr_logfile=$(mktemp /tmp/wsrep_recovery.XXXXXX) # safety checks if [ -z $wr_logfile ]; then log_error "WSREP: mktemp failed" return 1 fi if [ -f $wr_logfile ]; then [ "$euid" = "0" ] && chown $user $wr_logfile chmod 600 $wr_logfile else log_error "WSREP: mktemp failed" return 1 fi local wr_pidfile="$DATADIR/"`hostname`"-recover.pid" local wr_options="--disable-log-error --pid-file='$wr_pidfile'" log_notice "WSREP: Running position recovery with $wr_options" eval "$mysqld_cmd --wsrep_recover $wr_options 2> $wr_logfile" local rp="$(grep 'WSREP: Recovered position:' $wr_logfile)" if [ -z "$rp" ]; then local skipped="$(grep WSREP $wr_logfile | grep 'skipping position recovery')" if [ -z "$skipped" ]; then log_error "WSREP: Failed to recover position: '`cat $wr_logfile`'" ret=1 else log_notice "WSREP: Position recovery skipped" fi else local start_pos="$(echo $rp | sed 's/.*WSREP\:\ Recovered\ position://' \ | sed 's/^[ \t]*//')" log_notice "WSREP: Recovered position $start_pos" wsrep_start_position_opt="--wsrep_start_position=$start_pos" fi [ $ret -eq 0 ] && rm $wr_logfile return $ret } check_executable_location() { if test "$unsafe_my_cnf" = 1 -a "$unrecognized_handling" != collect; then log_error "Cannot accept $1 from a config file, when my.cnf is in the datadir" exit 1 fi } parse_arguments() { for arg do val=`echo "$arg" | sed -e "s;--[^=]*=;;"` case "$arg" in # these get passed explicitly to mysqld --basedir=*) MY_BASEDIR_VERSION="$val" ;; --datadir=*|--data=*) DATADIR="$val" ;; --pid[-_]file=*) pid_file="$val" ;; --plugin[-_]dir=*) PLUGIN_DIR="$val" ;; --user=*) user="$val"; SET_USER=1 ;; --log[-_]basename=*|--hostname=*|--loose[-_]log[-_]basename=*) pid_file="$val.pid"; err_log_base="$val"; ;; # these might have been set in a [mysqld_safe] section of my.cnf # they are added to mysqld command line to override settings from my.cnf --skip[-_]log[-_]error) err_log=; skip_err_log=1; ;; --log[-_]error=*) err_log="$val"; skip_err_log=0; ;; --port=*) mysql_tcp_port="$val" ;; --socket=*) mysql_unix_port="$val" ;; # mysqld_safe-specific options - must be set in my.cnf ([mysqld_safe])! --core[-_]file[-_]size=*) core_file_size="$val" ;; --ledir=*) check_executable_location "$arg" ; ledir="$val" ;; --malloc[-_]lib=*) check_executable_location "$arg"; set_malloc_lib "$val" ;; --crash[-_]script=*) check_executable_location "$arg"; crash_script="$val" ;; --mysqld=*) check_executable_location "$arg"; MYSQLD="$val" ;; --mysqld[-_]version=*) if test -n "$val" then check_executable_location "$arg" MYSQLD="mysqld-$val" PLUGIN_VARIANT="/$val" else MYSQLD="mysqld" fi ;; --dry[-_]run) dry_run=1 ;; --nice=*) niceness="$val" ;; --nowatch|--no[-_]watch|--no[-_]auto[-_]restart) nowatch=1 ;; --open[-_]files[-_]limit=*) open_files="$val" ;; --skip[-_]kill[-_]mysqld*) KILL_MYSQLD=0 ;; --syslog) want_syslog=1 ;; --skip[-_]syslog) want_syslog=0 ;; --syslog[-_]tag=*) syslog_tag="$val" ;; --timezone=*) TZ="$val"; export TZ; ;; --flush[-_]caches) flush_caches=1 ;; --numa[-_]interleave) numa_interleave=1 ;; --wsrep[-_]on) wsrep_on=1 append_arg_to_args "$arg" ;; --skip[-_]wsrep[-_]on) wsrep_on=0 append_arg_to_args "$arg" ;; --wsrep[-_]on=*) if echo $val | grep -iq '\(ON\|1\)'; then wsrep_on=1 else wsrep_on=0 fi append_arg_to_args "$arg" ;; --wsrep[-_]urls=*) wsrep_urls="$val"; ;; --wsrep[-_]provider=*) if test -n "$val" && test "$val" != "none" then wsrep_restart=1 fi append_arg_to_args "$arg" ;; --defaults-group-suffix=*) defaults_group_suffix="$arg" ;; --help) usage ;; *) case "$unrecognized_handling" in collect) append_arg_to_args "$arg" ;; complain) log_error "unknown option '$arg'" ;; esac esac done } # Add a single shared library to the list of libraries which will be added to # LD_PRELOAD for mysqld # # Since LD_PRELOAD is a space-separated value (for historical reasons), if a # shared lib's path contains spaces, that path will be prepended to # LD_LIBRARY_PATH and stripped from the lib value. add_mysqld_ld_preload() { lib_to_add="$1" log_notice "Adding '$lib_to_add' to LD_PRELOAD for mysqld" case "$lib_to_add" in *' '*) # Must strip path from lib, and add it to LD_LIBRARY_PATH lib_file=`basename "$lib_to_add"` case "$lib_file" in *' '*) # The lib file itself has a space in its name, and can't # be used in LD_PRELOAD log_error "library name '$lib_to_add' contains spaces and can not be used with LD_PRELOAD" exit 1 ;; esac lib_path=`dirname "$lib_to_add"` lib_to_add="$lib_file" [ -n "$mysqld_ld_library_path" ] && mysqld_ld_library_path="$mysqld_ld_library_path:" mysqld_ld_library_path="$mysqld_ld_library_path$lib_path" ;; esac # LD_PRELOAD is a space-separated [ -n "$mysqld_ld_preload" ] && mysqld_ld_preload="$mysqld_ld_preload " mysqld_ld_preload="${mysqld_ld_preload}$lib_to_add" } # Returns LD_PRELOAD (and LD_LIBRARY_PATH, if needed) text, quoted to be # suitable for use in the eval that calls mysqld. # # All values in mysqld_ld_preload are prepended to LD_PRELOAD. mysqld_ld_preload_text() { text= if [ -n "$mysqld_ld_preload" ]; then new_text="$mysqld_ld_preload" [ -n "$LD_PRELOAD" ] && new_text="$new_text $LD_PRELOAD" text="${text}LD_PRELOAD="`shell_quote_string "$new_text"`' ' fi if [ -n "$mysqld_ld_library_path" ]; then new_text="$mysqld_ld_library_path" [ -n "$LD_LIBRARY_PATH" ] && new_text="$new_text:$LD_LIBRARY_PATH" text="${text}LD_LIBRARY_PATH="`shell_quote_string "$new_text"`' ' fi echo "$text" } mysql_config= get_mysql_config() { if [ -z "$mysql_config" ]; then mysql_config=`echo "$0" | sed 's,/[^/][^/]*$,/mysql_config,'` if [ ! -x "$mysql_config" ]; then log_error "Can not run mysql_config $@ from '$mysql_config'" exit 1 fi fi "$mysql_config" "$@" } # set_malloc_lib LIB # - If LIB is empty, do nothing and return # - If LIB is 'tcmalloc', look for tcmalloc shared library in /usr/lib # then pkglibdir. tcmalloc is part of the Google perftools project. # - If LIB is an absolute path, assume it is a malloc shared library # # Put LIB in mysqld_ld_preload, which will be added to LD_PRELOAD when # running mysqld. See ld.so for details. set_malloc_lib() { malloc_lib="$1" if [ "$malloc_lib" = tcmalloc ]; then pkglibdir=`get_mysql_config --variable=pkglibdir` malloc_lib= # This list is kept intentionally simple. Simply set --malloc-lib # to a full path if another location is desired. for libdir in /usr/lib "$pkglibdir" "$pkglibdir/mysql"; do for flavor in _minimal '' _and_profiler _debug; do tmp="$libdir/libtcmalloc$flavor.so" #log_notice "DEBUG: Checking for malloc lib '$tmp'" [ -r "$tmp" ] || continue malloc_lib="$tmp" break 2 done done if [ -z "$malloc_lib" ]; then log_error "no shared library for --malloc-lib=tcmalloc found in /usr/lib or $pkglibdir" exit 1 fi fi # Allow --malloc-lib='' to override other settings [ -z "$malloc_lib" ] && return case "$malloc_lib" in /*) if [ ! -r "$malloc_lib" ]; then log_error "--malloc-lib '$malloc_lib' can not be read and will not be used" exit 1 fi ;; *) log_error "--malloc-lib must be an absolute path or 'tcmalloc'; " \ "ignoring value '$malloc_lib'" exit 1 ;; esac add_mysqld_ld_preload "$malloc_lib" } # # First, try to find BASEDIR and ledir (where mysqld is) # MY_PWD=`dirname $0` MY_PWD=`cd "$MY_PWD"/.. && pwd` # Check for the directories we would expect from a binary release install if test -n "$MY_BASEDIR_VERSION" -a -d "$MY_BASEDIR_VERSION" then # BASEDIR is already overridden on command line. Do not re-set. # Use BASEDIR to discover le. if test -x "$MY_BASEDIR_VERSION/libexec/mysqld" then ledir="$MY_BASEDIR_VERSION/libexec" elif test -x "$MY_BASEDIR_VERSION/sbin/mysqld" then ledir="$MY_BASEDIR_VERSION/sbin" else ledir="$MY_BASEDIR_VERSION/bin" fi elif test -x "$MY_PWD/bin/mysqld" then MY_BASEDIR_VERSION="$MY_PWD" # Where bin, share and data are ledir="$MY_PWD/bin" # Where mysqld is # Check for the directories we would expect from a source install elif test -x "$MY_PWD/libexec/mysqld" then MY_BASEDIR_VERSION="$MY_PWD" # Where libexec, share and var are ledir="$MY_PWD/libexec" # Where mysqld is elif test -x "$MY_PWD/sbin/mysqld" then MY_BASEDIR_VERSION="$MY_PWD" # Where sbin, share and var are ledir="$MY_PWD/sbin" # Where mysqld is # Since we didn't find anything, used the compiled-in defaults else MY_BASEDIR_VERSION='/usr' ledir='/usr/sbin' fi helper=`find_in_bin mysqld_safe_helper` print_defaults=`find_in_bin my_print_defaults` # # Second, try to find the data directory # # Try where the binary installs put it if test -d $MY_BASEDIR_VERSION/data/mysql then DATADIR=$MY_BASEDIR_VERSION/data if test -z "$defaults" -a -r "$DATADIR/my.cnf" then defaults="--defaults-extra-file=$DATADIR/my.cnf" fi # Next try where the source installs put it elif test -d $MY_BASEDIR_VERSION/var/mysql then DATADIR=$MY_BASEDIR_VERSION/var # Or just give up and use our compiled-in default else DATADIR=/var/lib/mysql fi if test -z "$MYSQL_HOME" then if test -r "$MY_BASEDIR_VERSION/my.cnf" && test -r "$DATADIR/my.cnf" then log_error "WARNING: Found two instances of my.cnf - $MY_BASEDIR_VERSION/my.cnf and $DATADIR/my.cnf IGNORING $DATADIR/my.cnf" MYSQL_HOME=$MY_BASEDIR_VERSION elif test -r "$DATADIR/my.cnf" then log_error "WARNING: Found $DATADIR/my.cnf The data directory is a deprecated location for my.cnf, please move it to $MY_BASEDIR_VERSION/my.cnf" unsafe_my_cnf=1 MYSQL_HOME=$DATADIR else MYSQL_HOME=$MY_BASEDIR_VERSION fi fi export MYSQL_HOME append_arg_to_args () { args="$args "`shell_quote_string "$1"` } args= # Get first arguments from the my.cnf file, groups [mysqld] and [mysqld_safe] # and then merge with the command line arguments SET_USER=2 parse_arguments `$print_defaults $defaults --loose-verbose --mysqld` if test $SET_USER -eq 2 then SET_USER=0 fi # If arguments come from [mysqld_safe] section of my.cnf # we complain about unrecognized options unrecognized_handling=complain parse_arguments `$print_defaults $defaults --loose-verbose mysqld_safe safe_mysqld mariadb_safe` # We only need to pass arguments through to the server if we don't # handle them here. So, we collect unrecognized options (passed on # the command line) into the args variable. unrecognized_handling=collect parse_arguments "$@" # # Try to find the plugin directory # # Use user-supplied argument if [ -n "${PLUGIN_DIR}" ]; then plugin_dir="${PLUGIN_DIR}" else # Try to find plugin dir relative to basedir for dir in lib64/mysql/plugin lib64/plugin lib/mysql/plugin lib/plugin do if [ -d "${MY_BASEDIR_VERSION}/${dir}" ]; then plugin_dir="${MY_BASEDIR_VERSION}/${dir}" break fi done # Give up and use compiled-in default if [ -z "${plugin_dir}" ]; then plugin_dir='/usr/lib64/mysql/plugin' fi fi plugin_dir="${plugin_dir}${PLUGIN_VARIANT}" # Determine what logging facility to use # Ensure that 'logger' exists, if it's requested if [ $want_syslog -eq 1 ] then my_which logger > /dev/null 2>&1 if [ $? -ne 0 ] then log_error "--syslog requested, but no 'logger' program found. Please ensure that 'logger' is in your PATH, or do not specify the --syslog option to mysqld_safe." exit 1 fi fi if [ $skip_err_log -eq 1 ] then append_arg_to_args "--skip-log-error" fi if [ -n "$err_log" -o $want_syslog -eq 0 ] then if [ -n "$err_log" ] then # mysqld adds ".err" if there is no extension on the --log-error # argument; must match that here, or mysqld_safe will write to a # different log file than mysqld # mysqld does not add ".err" to "--log-error=foo."; it considers a # trailing "." as an extension if expr "$err_log" : '.*\.[^/]*$' > /dev/null then : else err_log="$err_log".err fi case "$err_log" in /* ) ;; * ) err_log="$DATADIR/$err_log" ;; esac else if [ -n "$err_log_base" ] then err_log=$err_log_base.err case "$err_log" in /* ) ;; * ) err_log="$DATADIR/$err_log" ;; esac else err_log=$DATADIR/`hostname`.err fi fi append_arg_to_args "--log-error=$err_log" if [ $want_syslog -eq 1 ] then # User explicitly asked for syslog, so warn that it isn't used log_error "Can't log to error log and syslog at the same time. Remove all --log-error configuration options for --syslog to take effect." want_syslog=0 fi # Log to err_log file log_notice "Logging to '$err_log'." logging=file else if [ -n "$syslog_tag" ] then # Sanitize the syslog tag syslog_tag=`echo "$syslog_tag" | sed -e 's/[^a-zA-Z0-9_-]/_/g'` syslog_tag_mysqld_safe="${syslog_tag_mysqld_safe}-$syslog_tag" syslog_tag_mysqld="${syslog_tag_mysqld}-$syslog_tag" fi log_notice "Logging to syslog." logging=syslog fi USER_OPTION="" if test -w / -o "$USER" = "root" then if test "$user" != "root" -o $SET_USER = 1 then USER_OPTION="--user=$user" fi if test -n "$open_files" then ulimit -n $open_files fi fi if test -n "$open_files" then append_arg_to_args "--open-files-limit=$open_files" fi safe_mysql_unix_port=${mysql_unix_port:-${MYSQL_UNIX_PORT:-/var/lib/mysql/mysql.sock}} # Make sure that directory for $safe_mysql_unix_port exists mysql_unix_port_dir=`dirname $safe_mysql_unix_port` if [ ! -d $mysql_unix_port_dir -a $dry_run -eq 0 ] then if ! mkdir -p $mysql_unix_port_dir then log_error "Fatal error Can't create database directory '$mysql_unix_port'" exit 1 fi chown $user $mysql_unix_port_dir chmod 755 $mysql_unix_port_dir fi # If the user doesn't specify a binary, we assume name "mysqld" if test -z "$MYSQLD" then MYSQLD=mysqld fi if test ! -x "$ledir/$MYSQLD" then log_error "The file $ledir/$MYSQLD does not exist or is not executable. Please cd to the mysql installation directory and restart this script from there as follows: ./bin/mysqld_safe& See http://dev.mysql.com/doc/mysql/en/mysqld-safe.html for more information" exit 1 fi if test -z "$pid_file" then pid_file="`hostname`.pid" fi # MariaDB wants pid file without datadir append_arg_to_args "--pid-file=$pid_file" case "$pid_file" in /* ) ;; * ) pid_file="$DATADIR/$pid_file" ;; esac if test -n "$mysql_unix_port" then append_arg_to_args "--socket=$mysql_unix_port" fi if test -n "$mysql_tcp_port" then append_arg_to_args "--port=$mysql_tcp_port" fi if test $niceness -eq 0 then NOHUP_NICENESS="nohup" else NOHUP_NICENESS="nohup nice -$niceness" fi # Using nice with no args to get the niceness level is GNU-specific. # This check could be extended for other operating systems (e.g., # BSD could use "nohup sh -c 'ps -o nice -p $$' | tail -1"). # But, it also seems that GNU nohup is the only one which messes # with the priority, so this is okay. if nohup nice > /dev/null 2>&1 then normal_niceness=`nice` nohup_niceness=`nohup nice 2>/dev/null` numeric_nice_values=1 for val in $normal_niceness $nohup_niceness do case "$val" in -[0-9] | -[0-9][0-9] | -[0-9][0-9][0-9] | \ [0-9] | [0-9][0-9] | [0-9][0-9][0-9] ) ;; * ) numeric_nice_values=0 ;; esac done if test $numeric_nice_values -eq 1 then nice_value_diff=`expr $nohup_niceness - $normal_niceness` if test $? -eq 0 && test $nice_value_diff -gt 0 && \ nice --$nice_value_diff echo testing > /dev/null 2>&1 then # nohup increases the priority (bad), and we are permitted # to lower the priority with respect to the value the user # might have been given niceness=`expr $niceness - $nice_value_diff` NOHUP_NICENESS="nice -$niceness nohup" fi fi else if nohup echo testing > /dev/null 2>&1 then : else # nohup doesn't work on this system NOHUP_NICENESS="" fi fi # Try to set the core file size (even if we aren't root) because many systems # don't specify a hard limit on core file size. if test -n "$core_file_size" then ulimit -c $core_file_size fi # # If there exists an old pid file, check if the daemon is already running # Note: The switches to 'ps' may depend on your operating system if test -f "$pid_file" && [ $dry_run -eq 0 ] then PID=`cat "$pid_file"` if kill -0 $PID > /dev/null 2> /dev/null then if ps wwwp $PID | grep -v mysqld_safe | grep -- $MYSQLD > /dev/null then # The pid contains a mysqld process log_error "A mysqld process already exists" exit 1 fi fi rm -f "$pid_file" if test -f "$pid_file" then log_error "Fatal error: Can't remove the pid file: $pid_file Please remove it manually and start $0 again; mysqld daemon not started" exit 1 fi fi # # Flush and purge buffers/caches. # if true && test $flush_caches -eq 1 then # Locate sync, ensure it exists. if ! my_which sync > /dev/null 2>&1 then log_error "sync command not found, required for --flush-caches" exit 1 # Flush file system buffers. elif ! sync then # Huh, the sync() function is always successful... log_error "sync failed, check if sync is properly installed" fi # Locate sysctl, ensure it exists. if ! my_which sysctl > /dev/null 2>&1 then log_error "sysctl command not found, required for --flush-caches" exit 1 # Purge page cache, dentries and inodes. elif ! sysctl -q -w vm.drop_caches=3 then log_error "sysctl failed, check the error message for details" exit 1 fi elif test $flush_caches -eq 1 then log_error "--flush-caches is not supported on this platform" exit 1 fi # # Uncomment the following lines if you want all tables to be automatically # checked and repaired during startup. You should add sensible key_buffer # and sort_buffer values to my.cnf to improve check performance or require # less disk space. # Alternatively, you can start mysqld with the "myisam-recover" option. See # the manual for details. # # echo "Checking tables in $DATADIR" # $MY_BASEDIR_VERSION/bin/myisamchk --silent --force --fast --medium-check $DATADIR/*/*.MYI # $MY_BASEDIR_VERSION/bin/isamchk --silent --force $DATADIR/*/*.ISM # Does this work on all systems? #if type ulimit | grep "shell builtin" > /dev/null #then # ulimit -n 256 > /dev/null 2>&1 # Fix for BSD and FreeBSD systems #fi cmd="`mysqld_ld_preload_text`$NOHUP_NICENESS" [ $dry_run -eq 1 ] && cmd='' # # Set mysqld's memory interleave policy. # if true && test $numa_interleave -eq 1 then # Locate numactl, ensure it exists. if ! my_which numactl > /dev/null 2>&1 then log_error "numactl command not found, required for --numa-interleave" exit 1 # Attempt to run a command, ensure it works. elif ! numactl --interleave=all true then log_error "numactl failed, check if numactl is properly installed" fi # Launch mysqld with numactl. [ $dry_run -eq 0 ] && cmd="$cmd numactl --interleave=all" elif test $numa_interleave -eq 1 then log_error "--numa-interleave is not supported on this platform" exit 1 fi for i in "$ledir/$MYSQLD" "$defaults_group_suffix" "$defaults" "--basedir=$MY_BASEDIR_VERSION" \ "--datadir=$DATADIR" "--plugin-dir=$plugin_dir" "$USER_OPTION" do cmd="$cmd "`shell_quote_string "$i"` done cmd="$cmd $args" if [ $dry_run -eq 1 ] then # RETURN or EXIT depending if the script is being sourced or not. (return 2> /dev/null) && return || exit fi # Avoid 'nohup: ignoring input' warning test -n "$NOHUP_NICENESS" && cmd="$cmd < /dev/null" log_notice "Starting $MYSQLD daemon with databases from $DATADIR" # variable to track the current number of "fast" (a.k.a. subsecond) restarts fast_restart=0 # maximum number of restarts before trottling kicks in max_fast_restarts=5 # flag whether a usable sleep command exists have_sleep=1 # close stdout and stderr, everything goes to $logging now if expr "${-}" : '.*x' > /dev/null then : else exec 1>/dev/null exec 2>/dev/null fi # maximum number of wsrep restarts max_wsrep_restarts=0 while true do rm -f "$pid_file" # Some extra safety start_time=`date +%M%S` # Perform wsrep position recovery if wsrep_on=1, skip otherwise. if test $wsrep_on -eq 1 then # this sets wsrep_start_position_opt wsrep_recover_position "$cmd" [ $? -ne 0 ] && exit 1 # [ -n "$wsrep_urls" ] && url=`wsrep_pick_url $wsrep_urls` # check connect address if [ -z "$url" ] then eval_log_error "$cmd $wsrep_start_position_opt" else eval_log_error "$cmd $wsrep_start_position_opt --wsrep_cluster_address=$url" fi else eval_log_error "$cmd" fi end_time=`date +%M%S` if test ! -f "$pid_file" # This is removed if normal shutdown then break fi # sanity check if time reading is sane and there's sleep if test $end_time -gt 0 -a $have_sleep -gt 0 then # throttle down the fast restarts if test $end_time -eq $start_time then fast_restart=`expr $fast_restart + 1` if test $fast_restart -ge $max_fast_restarts then log_notice "The server is respawning too fast. Sleeping for 1 second." sleep 1 sleep_state=$? if test $sleep_state -gt 0 then log_notice "The server is respawning too fast and no working sleep command. Turning off trottling." have_sleep=0 fi fast_restart=0 fi else fast_restart=0 fi fi if true && test $KILL_MYSQLD -eq 1 then # Test if one process was hanging. # This is only a fix for Linux (running as base 3 mysqld processes) # but should work for the rest of the servers. # The only thing is ps x => redhat 5 gives warnings when using ps -x. # kill -9 is used or the process won't react on the kill. numofproces=`ps xaww | grep -v "grep" | grep "$ledir/$MYSQLD\>" | grep -c "pid-file=$pid_file"` log_notice "Number of processes running now: $numofproces" I=1 while test "$I" -le "$numofproces" do PROC=`ps xaww | grep "$ledir/$MYSQLD\>" | grep -v "grep" | grep "pid-file=$pid_file" | sed -n '$p'` for T in $PROC do break done # echo "TEST $I - $T **" if kill -9 $T then log_error "$MYSQLD process hanging, pid $T - killed" else break fi I=`expr $I + 1` done fi if [ -n "$wsrep_restart" ] then if [ $wsrep_restart -le $max_wsrep_restarts ] then wsrep_restart=`expr $wsrep_restart + 1` log_notice "WSREP: sleeping 15 seconds before restart" sleep 15 else log_notice "WSREP: not restarting wsrep node automatically" break fi fi log_notice "mysqld restarted" if test -n "$crash_script" then crash_script_output=`$crash_script 2>&1` log_error "$crash_script_output" fi done log_notice "mysqld from pid file $pid_file ended"
Save